Add Honeycomb bridge domain management tests
[csit.git] / bootstrap.sh
index f28524a..de6cd37 100755 (executable)
@@ -1,12 +1,25 @@
 #!/bin/bash
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
 
 set -x
 
-#sudo apt-get -y install libpython2.7-dev
+cat /etc/hostname
+cat /etc/hosts
 
-#VIRL_VMS="10.30.51.53,10.30.51.51,10.30.51.52"
-#IFS=',' read -ra ADDR <<< "${VIRL_VMS}"
-#
+export DEBIAN_FRONTEND=noninteractive
+sudo apt-get -y update
+sudo apt-get -y install libpython2.7-dev python-virtualenv
 
 function ssh_do() {
     echo
@@ -14,21 +27,6 @@ function ssh_do() {
     ssh -i priv_key -o StrictHostKeyChecking=no $@
 }
 
-#for addr in "${ADDR[@]}"; do
-#    echo
-#    echo ${addr}
-#    echo
-#
-#    ssh_do cisco@${addr} hostname || true
-#    ssh_do cisco@${addr} "ifconfig -a" || true
-#    ssh_do cisco@${addr} "lspci -Dnn | grep 0200" || true
-#    ssh_do cisco@${addr} "free -m" || true
-#    ssh_do cisco@${addr} "cat /proc/meminfo" || true
-#    ssh_do cisco@${addr} "dpkg -l vpp\*" || true
-#    ssh_do cisco@${addr} "lshw -c network" || true
-#    ssh_do cisco@${addr} "sudo -S sh -c 'echo exec show  hardware | vpp_api_test '"
-#done
-
 VIRL_SERVER=10.30.51.28
 VIRL_USERNAME=jenkins-in
 VIRL_PKEY=priv_key
@@ -67,13 +65,20 @@ chmod 600 priv_key
 
 # Temporarily download VPP packages from nexus.fd.io
 
-rm -f *.deb
-wget -q "https://nexus.fd.io/service/local/repositories/fd.io.dev/content/io/fd/vpp/vpp/1.0.0-185~gca0f3b3_amd64/vpp-1.0.0-185~gca0f3b3_amd64.deb" || exit
-wget -q "https://nexus.fd.io/service/local/repositories/fd.io.dev/content/io/fd/vpp/vpp-dbg/1.0.0-185~gca0f3b3_amd64/vpp-dbg-1.0.0-185~gca0f3b3_amd64.deb" || exit
-wget -q "https://nexus.fd.io/service/local/repositories/fd.io.dev/content/io/fd/vpp/vpp-dev/1.0.0-185~gca0f3b3_amd64/vpp-dev-1.0.0-185~gca0f3b3_amd64.deb" || exit
-wget -q "https://nexus.fd.io/service/local/repositories/fd.io.dev/content/io/fd/vpp/vpp-dpdk-dev/1.0.0-185~gca0f3b3_amd64/vpp-dpdk-dev-1.0.0-185~gca0f3b3_amd64.deb" || exit
-wget -q "https://nexus.fd.io/service/local/repositories/fd.io.dev/content/io/fd/vpp/vpp-dpdk-dkms/1.0.0-185~gca0f3b3_amd64/vpp-dpdk-dkms-1.0.0-185~gca0f3b3_amd64.deb" || exit
-wget -q "https://nexus.fd.io/service/local/repositories/fd.io.dev/content/io/fd/vpp/vpp-lib/1.0.0-185~gca0f3b3_amd64/vpp-lib-1.0.0-185~gca0f3b3_amd64.deb" || exit
+if [ "${#}" -ne "0" ]; then
+    arr=(${@})
+    echo ${arr[0]}
+else
+    rm -f *.deb
+    VPP_STABLE_VER="1.0.0-437~g8f15e92_amd64"
+    VPP_REPO_URL="https://nexus.fd.io/service/local/repositories/fd.io.dev/content/io/fd/vpp"
+    wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-dpdk-dev/${VPP_STABLE_VER}/vpp-dpdk-dev-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${VPP_STABLE_VER}/vpp-dpdk-dkms-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}.deb" || exit
+fi
 
 VPP_DEBS=(*.deb)
 echo ${VPP_DEBS[@]}
@@ -109,14 +114,14 @@ function stop_virl_simulation {
 
 VIRL_SID=$(ssh -i priv_key -o StrictHostKeyChecking=no \
     ${VIRL_USERNAME}@${VIRL_SERVER} \
-    "/home/jenkins-in/testcase-infra/bin/start-testcase simple-ring ${VPP_DEBS_FULL[@]}")
+    "/home/jenkins-in/testcase-infra/bin/start-testcase -c double-ring-nested ${VPP_DEBS_FULL[@]}")
 retval=$?
 if [ "$?" -ne "0" ]; then
     echo "VIRL simulation start failed"
     exit ${retval}
 fi
 
-if [ "x${VIRL_SID}" == "x" ]; then
+if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
     echo "No VIRL session ID reported."
     exit 127
 fi
@@ -145,11 +150,21 @@ virtualenv env
 echo pip install
 pip install -r requirements.txt
 
+pykwalify -s resources/topology_schemas/3_node_topology.sch.yaml \
+          -s resources/topology_schemas/topology.sch.yaml \
+          -d topologies/enabled/topology.yaml \
+          -vvv
+
+result=$?
+if [ "${result}" -ne "0" ]; then
+    echo "Topology schema validation failed."
+    echo "However, the tests will start."
+fi
+
 PYTHONPATH=`pwd` pybot -L TRACE \
     -v TOPOLOGY_PATH:topologies/enabled/topology.yaml \
-    --include vm_env \
-    --include 3_NODE_SINGLE_LINK_TOPO \
-    --exclude 3_node_double_link_topoNOT3_node_single_link_topo \
+    --include vm_envAND3_node_single_link_topo \
+    --include vm_envAND3_node_double_link_topo \
     --exclude PERFTEST \
     --noncritical EXPECTED_FAILING \
     tests/